@################################################################################
@# Copyright (c) 2008-2011 Computer Line Associates. All Rights Reserved
@#
@# Elena - 3D CAD Interface
@#
@# This file is an EmPy template, EmPy is a system for embedding Python
@# expressions and statements in template text. 
@# The official URL for this Web site is http://www.alcyone.com/software/empy/
@################################################################################
$*
$* Created by: Elena @elenaVersion for PDMS at @dateTime
$* Project : @projectCode
$*

var !module BANNER NAME
var !module (upcase('$!module'))
if (match(|$!MODULE|,|MONIT|) GT 0) then
    dev tty
endif

if (match(|$!MODULE|,|PARAGON|) LT 1) then
    PARAGON
endif

$W250

@iniParams.uom.ltab_dist DIST

/BLTA_@projectCode
handle (41,69)
   NEW BLTA /BLTA_@projectCode
endhandle

/LTAB_@projectCode
handle (41,69)
   NEW LTAB /LTAB_@projectCode
endhandle

@{
# Empty values
_Empty = [None, '']
_MaxPnumLength = 77
_use_mark_code = True
_use_custom_code = False
_use_bolt_weight = False
_mark_code_const = "PNUM"
_res_mark_const = "PNUM"
_custom_code_const = "CUSTOM_CODE1"
_res_cust_code_const = "CUSTOM_CODE"
_weight_const = "BWEI"

# Base identation
_bi = 4

def pr(row, spaces=0):
    """Print the row"""
    print  (" " * spaces) + row
    
# Create the blis items
for ltabItem in ltabItems:
    pr("/DTAB_%s" % ltabItem["DTAB"])
    pr("handle (41,69)")
    pr("NEW DTAB /DTAB_%s" % ltabItem["DTAB"], _bi)
    pr("endhandle")
    pr("BLEN (%s)" % ltabItem["BLEN"])
    if _use_mark_code:
        if  len(ltabItem[_mark_code_const]) > _MaxPnumLength:
            code = ltabItem[_mark_code_const]
            codes = (ltabItem[_mark_code_const]).split(" ")
            
            size = (len(codes[0]) + 1) * (_MaxPnumLength / (len(codes[0]) + 1 ))
            rescodes = [code[start:start+size] for start in range(0, len(code), size)]
                    
            for x in range(len(rescodes)):
                if rescodes[x] not in _Empty:
                    res = ":" + _res_mark_const + str(x+1) + " '" + rescodes[x].strip() + "'"
                    pr(res)
        else:
            pr(":%s '%s'" % ( _mark_code_const, ltabItem[_mark_code_const] ) )
    pr("")
    if _use_custom_code:
        if  len(ltabItem[_custom_code_const]) > _MaxPnumLength:
            code = ltabItem[_custom_code_const]
            codes = (ltabItem[_custom_code_const]).split(" ")
            
            size = (len(codes[0]) + 1) * (_MaxPnumLength / (len(codes[0]) + 1 ))
            rescodes = [code[start:start+size] for start in range(0, len(code), size)]
                    
            for x in range(len(rescodes)):
                if rescodes[x] not in _Empty:
                    res = ":" + _res_cust_code_const + str(x+1) + " '" + rescodes[x].strip() + "'"
                    pr(res)
        else:
            pr(":%s '%s'" % ( _custom_code_const, ltabItem[_custom_code_const] ) )
    pr("")
    if _use_bolt_weight:
        if  len(ltabItem[_weight_const]) > _MaxPnumLength:
            code = ltabItem[_weight_const]
            codes = (ltabItem[_weight_const]).split(" ")
            
            size = (len(codes[0]) + 1) * (_MaxPnumLength / (len(codes[0]) + 1 ))
            rescodes = [code[start:start+size] for start in range(0, len(code), size)]
                    
            for x in range(len(rescodes)):
                if rescodes[x] not in _Empty:
                    res = ":" + _weight_const + str(x+1) + " '" + rescodes[x].strip() + "'"
                    pr(res)
        else:
            pr(":%s '%s'" % ( _weight_const, ltabItem[_weight_const] ) )
    pr("")
    
}
